#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "odicon.h"
#include "quadratic.h"


static double **a, *b;
static double ifunc(int dim, int x[]) { return quadratic2(dim, x, a, b); }

static void read_param(const int dim, int *init) {
    a = fmatrix_new(dim, dim);
    b = fvector_new(dim);
    if (!fmatrix_scan(dim, a)) return;
    if (!fvector_scan(dim, b)) return;
    if (!ivector_scan(dim, init)) return;

    /* fmatrix_print(dim, a); */
    /* fvector_print(dim, b); */
}

void demo_quadratic(const int dim, char MorL) {
    int i;
    int init[100];
    int upper[100];
    int lower[100];

    for (i=0; i<dim; i++) { lower[i] = -100; upper[i] = 100; }
    read_param(dim, init);

    switch (MorL) {
    case 'M':
        mgconv_minimize(dim, ifunc, init, lower, upper);
        break;
    case 'L':
        lgconv_minimize(dim, ifunc, init);
        /* lgconv_minimize_IFF(dim, ifunc, init); */
        /*lgconv_minimize_FW(dim, ifunc, init); */
        break;
    default:
        assert(0!=0);
        break;
    }
}
